Subject: Re: [MIB-DOCTORS] Heads-up MIB review impending

From: Benoit Claise <[email-masked]>
Date: Wed, 16 May 2012 12:53:38 +0200

Hi MIB doctors,

My bad for not following up on this one. I will follow more closely from 
now on.
Can we please have a volunteer to review this MIB module, which is on 
the IESG telechat for next Thursday.

Regards, Benoit.
> Hi MIB Doctors,
>
> Heads up to give you extra review time.
>
> https://datatracker.ietf.org/doc/draft-ietf-manet-nhdp-mib/ is going to IETF
> last call very soon and would benefit significantly from a MIB Doctor review by
> the end of the last call.
>
> Thanks for the work you do.
>
> Adrian
>
> _______________________________________________
> MIB-DOCTORS mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/mib-doctors
>
>

---

From: Benoit Claise <[email-masked]>
Date: Mon, 21 May 2012 12:09:23 +0200

Hi MIB doctors,

We would really benefit from your expertise here.
Can we please have a volunteer.
If we don't find someone by the end of the day (on telechat for this 
Thursday), I'm afraid that I will have to defer this draft to the next 
telechat...

Regards, Benoit.

> Hi MIB doctors,
>
> My bad for not following up on this one. I will follow more closely 
> from now on.

---

From: Benoit Claise <[email-masked]>
Date: Tue, 22 May 2012 00:15:26 +0200

Dear all,

I have deferred this draft for the next telechat.

Regards, Benoit.

---

From: "Bert Wijnen \(IETF\)" <[email-masked]>
Date: Tue, 22 May 2012 11:11:20 +0200

This is by no means a full MIB review, but I did a quick SMICng SYNTAX check:

W: f(nhdp.mi2), (778,5) Row "nhdpLibRemovedIfAddrSetEntry" has indexing
      that  may create variables with more than 128 sub-ids
W: f(nhdp.mi2), (1221,5) Row "nhdpIib2HopSetEntry" has indexing that may
      create variables with more than 128 sub-ids
W: f(nhdp.mi2), (1117,16) Row "nhdpIibLinkSetEntry" does not have a
      consistent  indexing scheme - index item nhdpDiscIfIndex from base
      row nhdpDiscIfSetEntry  is not defined as an index item
W: f(nhdp.mi2), (1376,15) Row "nhdpNibNeighborSetEntry" does not have a
      consistent indexing scheme - index item nhdpDiscRouterIndex from base
      row nhdpDiscIfSetEntry is not defined as an index item
W: f(nhdp.mi2), (1425,16) Row "nhdpNibLostNeighborSetEntry" does not have
      a consistent indexing scheme - index item nhdpDiscRouterIndex from base
      row nhdpDiscIfSetEntry is not defined as an index item
W: f(nhdp.mi2), (1614,16) Row "nhdpDiscIfSetPerfEntry" does not have a
      consistent indexing scheme - index item nhdpDiscIfIndex from base row
      nhdpDiscIfSetEntry is not defined as an index item
W: f(nhdp.mi2), (1690,16) Row "nhdpDiscNeighborSetPerfEntry" does not
      have a consistent indexing scheme - index item nhdpDiscRouterIndex from
      base row nhdpDiscIfSetEntry is not defined as an index item
W: f(nhdp.mi2), (1768,16) Row "nhdpIib2HopSetPerfEntry" does not have a
      consistent indexing scheme - index item nhdpDiscRouterIndex from base
      row nhdpDiscIfSetEntry is not defined as an index item
W: f(nhdp.mi2), (1941,21) Variable "nhdpIfIndex" in notification
      "nhdpNbrStateChange" is an index for a table
W: f(nhdp.mi2), (1956,21) Variable "nhdpIfIndex" in notification
     "nhdp2HopNbrStateChange" is an index for a table
W: f(nhdp.mi2), (1973,21) Variable "nhdpIfIndex" in notification
     "nhdpIfRxBadPacket" is anindex for a table
W: f(nhdp.mi2), (1992,21) Variable "nhdpIfIndex" in notification
     "nhdpIfStateChange" is anindex for a table
W: f(nhdp.mi2), (2142,22) Duplicate item "nhdpPerformanceGroup"
      in MANDATORY-GROUPS for module "NHDP-MIB"

The first  Warning got me to look at:
    nhdpLibRemovedIfAddrSetEntry  OBJECT-TYPE
       SYNTAX      NhdpLibRemovedIfAddrSetEntry
       MAX-ACCESS  not-accessible
       STATUS      current
       DESCRIPTION
          "A router's Removed Interface Address Set consists
          of Removed Interface Address Tuples, one per network
          address:

          (IR_local_iface_addr, IR_time)

          The association between these addrs and
          the router's Interface is found in the

          Standard MIB II's IP address table
          (RFC1213)."
       REFERENCE
          "RFC6130."
       INDEX { nhdpLibRemovedIfAddrSetIpAddrType,
               nhdpLibRemovedIfAddrSetIpAddr }
    ::= { nhdpLibRemovedIfAddrSetTable 1 }

    NhdpLibRemovedIfAddrSetEntry ::=
       SEQUENCE {
          nhdpLibRemovedIfAddrSetIpAddrType
            InetAddressType,
          nhdpLibRemovedIfAddrSetIpAddr
            InetAddress,
          nhdpLibRemovedIfAddrSetIpAddrPrefixLen
            InetAddressPrefixLength,
          nhdpLibRemovedIfAddrSetIfIndex
            InterfaceIndexOrZero,
          nhdpLibRemovedIfAddrSetIRTime
            TimeStamp
         }

   nhdpLibRemovedIfAddrSetIpAddrType  OBJECT-TYPE
      SYNTAX      InetAddressType
      MAX-ACCESS  read-only
      STATUS      current
      DESCRIPTION
         "The type of the nhdpLibRemovedIfAddrSetIpAddr
          in the InetAddress MIB (RFC4001).

          Only the values ipv4(1) and
          ipv6(2) are supported."
      REFERENCE
         "RFC6130."
   ::= { nhdpLibRemovedIfAddrSetEntry 1 }

   nhdpLibRemovedIfAddrSetIpAddr  OBJECT-TYPE
      SYNTAX      InetAddress
      MAX-ACCESS  read-only
      STATUS      current
      DESCRIPTION
         "nhdpLibRemovedIfAddrSetIpAddr is a
          recently used address of an interface of
          this router."
      REFERENCE
         "RFC6130."
   ::= { nhdpLibRemovedIfAddrSetEntry 2 }

And I note that:

- the 2 INDEX obbjects are defined read-only. Normally they would be
  not-accessible!!! See RFC2578
- If this is ALWAYS true:
     nhdpLibRemovedIfAddrSetIpAddrType  OBJECT-TYPE
        SYNTAX      InetAddressType
        MAX-ACCESS  read-only
        STATUS      current
        DESCRIPTION
         "The type of the nhdpLibRemovedIfAddrSetIpAddr
          in the InetAddress MIB (RFC4001).

          Only the values ipv4(1) and
          ipv6(2) are supported."
  Then you could do:
     nhdpLibRemovedIfAddrSetIpAddr  OBJECT-TYPE
        SYNTAX      InetAddress (SIZE(4|16))
        MAX-ACCESS  read-only
   Otherwise you would have to add something to description clause to
   warn implementers that they should consider OID size.

The third warning:
   W: f(nhdp.mi2), (1117,16) Row "nhdpIibLinkSetEntry" does not have a
        consistent  indexing scheme - index item nhdpDiscIfIndex from base
        row nhdpDiscIfSetEntry  is not defined as an index item
Seems a valid warning. But I am not 100% sure. I'd have to go and study
more detauil to determine.
Anyways, these "inconsistent indexing" warnings are indeed just
warnings. It may be OK, but it would be good to check and make sure
that this results in proper (i.e. unique) indexing values and that the
indexing is indeed as intended.

Sorry, not enough time to check more details now.

Bert

----- Original Message ----- 
From: "Benoit Claise" <[email-masked]>
To: <[email-masked]>
Cc: <[email-masked]>; <[email-masked]>;
<[email-masked]>
Sent: Tuesday, May 22, 2012 12:15 AM
Subject: Re: [MIB-DOCTORS] Heads-up MIB review impending

>>> My bad for not following up on this one. I will follow more closely from now
>>> on.
>>> Can we please have a volunteer to review this MIB module, which is on the
>>> IESG telechat for next Thursday.
>>>
>>> Regards, Benoit.
>>>> Hi MIB Doctors,
>>>>

---

From: "Bert Wijnen (IETF)" <[email-masked]>
Date: Tue, 22 May 2012 20:33:18 +0200

Unfortunately, there is not a free version (at least not current)
available as far as I know. I don;t understand why the author does not
just make it open source and available to everyone.
But that is his call I guess.

Oh by the way, you also already user { mib-2 998 } for the MIB OID!!!
that is not proper! You should use xxx or some such instead of 998
(as you indicate in the rfc-editor comment ;-)

Bert

On 5/22/12 7:03 PM, Ulrich Herberg wrote:
> Bert,
>
> thank you very much for this first review. We will work on fixing these and spin a new version.
>
> By the way, is there a free version of SMICng available? I only have smilint.
>
> Best regards
> Ulrich
>
> On Tue, May 22, 2012 at 2:11 AM, Bert Wijnen (IETF) <[email-masked] <mailto:[email-masked]>> wrote:
>
>           INDEX { nhdpLibRemovedIfAddrSetIpAddrT__ype,
>              nhdpLibRemovedIfAddrSetIpAddrT__ype
>                InetAddressType,
>              nhdpLibRemovedIfAddrSetIpAddrP__refixLen
>                InetAddressPrefixLength,
>       nhdpLibRemovedIfAddrSetIpAddrT__ype  OBJECT-TYPE
>          SYNTAX      InetAddressType
>          MAX-ACCESS  read-only
>          STATUS      current
>          DESCRIPTION
>         nhdpLibRemovedIfAddrSetIpAddrT__ype  OBJECT-TYPE
>            SYNTAX      InetAddressType
>            MAX-ACCESS  read-only
>            STATUS      current
>            DESCRIPTION
>     ----- Original Message ----- From: "Benoit Claise" <[email-masked] <mailto:[email-masked]>>
>
>     To: <[email-masked] <mailto:[email-masked]>>
>     Cc: <[email-masked] <mailto:[email-masked]>>; <[email-masked] <mailto:[email-masked]>>;
>     <[email-masked] <mailto:[email-masked]>>
>                     https://datatracker.ietf.org/__doc/draft-ietf-manet-nhdp-mib/
>                     <https://datatracker.ietf.org/doc/draft-ietf-manet-nhdp-mib/> is going to
>                     IETF
>                     _________________________________________________
>                     MIB-DOCTORS mailing list
>                     [email-masked] <mailto:[email-masked]>
>                     https://www.ietf.org/mailman/__listinfo/mib-doctors <https://www.ietf.org/mailman/listinfo/mib-doctors>
>
>
>
>                 _________________________________________________
>                 MIB-DOCTORS mailing list
>                 [email-masked] <mailto:[email-masked]>
>                 https://www.ietf.org/mailman/__listinfo/mib-doctors <https://www.ietf.org/mailman/listinfo/mib-doctors>
>
>
>
>             _________________________________________________
>             MIB-DOCTORS mailing list
>             [email-masked] <mailto:[email-masked]>
>             https://www.ietf.org/mailman/__listinfo/mib-doctors <https://www.ietf.org/mailman/listinfo/mib-doctors>
>
>
>
>         _________________________________________________
>         MIB-DOCTORS mailing list
>         [email-masked] <mailto:[email-masked]>
>         https://www.ietf.org/mailman/__listinfo/mib-doctors <https://www.ietf.org/mailman/listinfo/mib-doctors>
>
>
>

---

From: "Adrian Farrel" <[email-masked]>
Date: Tue, 22 May 2012 21:57:39 +0100

Ulrich,
 
just in case you are no aware of
http://www.ibr.cs.tu-bs.de/projects/libsmi/tools/
 
Adrian
 
From: Ulrich Herberg [mailto:[email-masked]] 
Sent: 22 May 2012 19:37
To: Bert Wijnen (IETF)
Cc: Benoit Claise; Adrian Farrel; [email-masked]; MIB Doctors
(E-mail); [email-masked]
Subject: Re: [MIB-DOCTORS] Heads-up MIB review impending
 
Bert,
On Tue, May 22, 2012 at 11:33 AM, Bert Wijnen (IETF) <[email-masked]>
wrote:

Okay, I see. My company will likely not pay for that, and personally I'd rather
go to vacations than buy a MIB compiler ;-)

I know, that has been discovered in the IESG LC. The reason why we did not put
xxxx there is that smilint complains otherwise and fails to compile. It will be
fixed in the next revision of the draft (or in the RFC editor queue).

Best
Ulrich

Bert

thank you very much for this first review. We will work on fixing these and spin
a new version.

Best regards
Ulrich
On Tue, May 22, 2012 at 2:11 AM, Bert Wijnen (IETF) <[email-masked]
<mailto:[email-masked]>> wrote:

              InetAddressPrefixLength,

        SYNTAX      InetAddressType
        MAX-ACCESS  read-only
        STATUS      current
        DESCRIPTION

   And I note that:

          SYNTAX      InetAddressType
          MAX-ACCESS  read-only
          STATUS      current
          DESCRIPTION

   The third warning:

   Bert
   ----- Original Message ----- From: "Benoit Claise" <[email-masked]
<mailto:[email-masked]>>

   To: <[email-masked] <mailto:[email-masked]>>
   Cc: <[email-masked] <mailto:[email-masked]>>;
<[email-masked] <mailto:[email-masked]>>;
   <[email-masked]
<mailto:[email-masked]>>

       Dear all,

       Regards, Benoit.

           Hi MIB doctors,

           We would really benefit from your expertise here.
           Can we please have a volunteer.
           If we don't find someone by the end of the day (on telechat for this
           Thursday), I'm afraid that I will have to defer this draft to the
next
           telechat...

           Regards, Benoit.

               Hi MIB doctors,

               My bad for not following up on this one. I will follow more
closely from now
               on.
               Can we please have a volunteer to review this MIB module, which
is on the
               IESG telechat for next Thursday.

               Regards, Benoit.

                   Hi MIB Doctors,

                   <https://datatracker.ietf.org/doc/draft-ietf-manet-nhdp-mib/>
is going to
                   IETF
                   last call very soon and would benefit significantly from a
MIB Doctor
                   review by
                   the end of the last call.

                   Adrian
                   _________________________________________________
                   MIB-DOCTORS mailing list
                   [email-masked] <mailto:[email-masked]>
                   https://www.ietf.org/mailman/__listinfo/mib-doctors
<https://www.ietf.org/mailman/listinfo/mib-doctors>

               _________________________________________________
               MIB-DOCTORS mailing list
               [email-masked] <mailto:[email-masked]>
               https://www.ietf.org/mailman/__listinfo/mib-doctors
<https://www.ietf.org/mailman/listinfo/mib-doctors>

           _________________________________________________
           MIB-DOCTORS mailing list
           [email-masked] <mailto:[email-masked]>
           https://www.ietf.org/mailman/__listinfo/mib-doctors
<https://www.ietf.org/mailman/listinfo/mib-doctors>

       _________________________________________________
       MIB-DOCTORS mailing list
       [email-masked] <mailto:[email-masked]>
       https://www.ietf.org/mailman/__listinfo/mib-doctors
<https://www.ietf.org/mailman/listinfo/mib-doctors>

---

From: Benoit Claise <[email-masked]>
Date: Fri, 25 May 2012 15:16:11 +0200

Dear all,

On the top of the quick SMICng SYNTAX check done by Bert Wijnen, Tom 
Nadeau accepted to review this MIB module.
Quoting Tom, "but not until late next week".
This will be on time for the next IESG telechat.

Thanks Tom.

Regards, Benoit.

> Adrian,
>
> thanks, I did not know that service. It seems to be a web interface 
> for smilint and related tools. But apparently, the SMICng tool 
> discoveres some more problems which smilint did not warn (e.g., the 
> max-access of the index objects).
>
> Best
> Ulrich
>
> On Tue, May 22, 2012 at 1:57 PM, Adrian Farrel <[email-masked] 
> <mailto:[email-masked]>> wrote:
>
>     Ulrich,
>
>     *From:*Ulrich Herberg [mailto:[email-masked]
>     <mailto:[email-masked]>]
>     *Sent:* 22 May 2012 19:37
>     *To:* Bert Wijnen (IETF)
>     *Cc:* Benoit Claise; Adrian Farrel; [email-masked]
>     <mailto:[email-masked]>; MIB Doctors (E-mail);
>     [email-masked]
>     <mailto:[email-masked]>
>
>
>     *Subject:* Re: [MIB-DOCTORS] Heads-up MIB review impending
>
>     Bert,
>
>     On Tue, May 22, 2012 at 11:33 AM, Bert Wijnen (IETF)
>     <[email-masked] <mailto:[email-masked]>> wrote:
>
>     Okay, I see. My company will likely not pay for that, and
>     personally I'd rather go to vacations than buy a MIB compiler ;-)
>
>
>     I know, that has been discovered in the IESG LC. The reason why we
>     did not put xxxx there is that smilint complains otherwise and
>     fails to compile. It will be fixed in the next revision of the
>     draft (or in the RFC editor queue).
>
>     Best
>     Ulrich
>
>
>         Bert
>
>
>
>             On Tue, May 22, 2012 at 2:11 AM, Bert Wijnen (IETF)
>             <[email-masked] <mailto:[email-masked]>
>             <mailto:[email-masked]
>             <mailto:[email-masked]>>> wrote:
>
>                W: f(nhdp.mi2), (778,5) Row
>             "nhdpLibRemovedIfAddrSetEntry" has indexing
>                W: f(nhdp.mi2), (1425,16) Row
>             "nhdpNibLostNeighborSetEntry" does not have
>                ----- Original Message ----- From: "Benoit Claise"
>             <[email-masked] <mailto:[email-masked]>
>             <mailto:[email-masked] <mailto:[email-masked]>>>
>
>                To: <[email-masked] <mailto:[email-masked]>
>             <mailto:[email-masked] <mailto:[email-masked]>>>
>                Cc: <[email-masked]
>             <mailto:[email-masked]>
>             <mailto:[email-masked]
>             <mailto:[email-masked]>>>;
>             <[email-masked] <mailto:[email-masked]>
>             <mailto:[email-masked] <mailto:[email-masked]>>>;
>             <http://tools.ietf.org>
>             <mailto:[email-masked]
>             <mailto:[email-masked]>>>
>
>
>                                last call very soon and would benefit
>             significantly from a MIB Doctor
>                                review by
>             <mailto:[email-masked] <mailto:[email-masked]>>
>             <mailto:[email-masked] <mailto:[email-masked]>>
>             <mailto:[email-masked] <mailto:[email-masked]>>
>             <mailto:[email-masked] <mailto:[email-masked]>>